//package com.fieldfx.devicehub;

import oscP5.OscP5;

class OscMap extends SerializableBase {
  
  public OscMap() {}
  
  public OscMap( String deviceName_, String oscPath_, String setFuncName_ ) {
    deviceName = deviceName_;
    oscPath = oscPath_;
    setFuncName = setFuncName_;
  }
  
  @Override
  public String getType () {
    return "OscMap";
  }
  
  @Override
  public OscMap clone () {
    return new OscMap();
  }
  
  @Override
  public void serialize ( Serializer s ) {
    deviceName = s.serialize( "deviceName", deviceName );
    oscPath = s.serialize( "oscPath", oscPath );
    setFuncName = s.serialize( "setFuncName", setFuncName );
  }
  
  public void plug ( OscP5 oscP5, DeviceConfig deviceConfig ) {
    Device device = deviceConfig.findDevice( deviceName );
    if( device != null ) {
      System.out.println( "plugging " + deviceName + " to " + oscPath );
      oscP5.plug( device, setFuncName, oscPath );
    }
  }
  
  public String deviceName  = "";
  public String oscPath     = "";
  public String setFuncName = "";
}
