

class EditState implements com.fieldfx.util.serialize.Serializable {  
  List<LightSet> sets            = new ArrayList<LightSet>();
  SequencePath   currentPath     = new SequencePath();
  
  //map sets to light indexes
  TreeMap<LightSet, Integer> setsToLights = new TreeMap<LightSet, Integer>();
  
  
  int                   editMode        = 0;
  public final int      place           = 0;
  public final int      move            = 1;
  public final int      sequence        = 2;
  public final int      config          = 3;
  
  // ------------------------------------------------------------------------------------------ //
  public String       getType   ( )              { return "EditState"; }
  public com.fieldfx.util.serialize.Serializable clone     ( )              { return new EditState(); }
  public void serialize ( Serializer s ) {
    editMode = s.serialize( "editMode",     editMode    );
               s.serialize( "currentPath",  currentPath );
               s.serialize( "sets",         sets        );
               
               
  }
  
  // ------------------------------------------------------------------------------------------ //
  public Vector2 findClosest( Vector2 from ) {
    
    if( sets != null && sets.size() > 0 ) {
      LightSet firstSet = sets.get(0);
      if( firstSet.lights != null && firstSet.lights.size() > 0 ) {
        Vector2 closest        = firstSet.lights.get(0);
        float   closestDistSqr = closest.sub( from ).lenlen();
        for( LightSet set : sets ) {
          //if( set == null ) continue;
          Vector2 closestInSet = set.findClosest( from );
          if( closestInSet != null ) {
            float   distSqr2ClosestInSet = closestInSet.sub( from ).lenlen();
            if( distSqr2ClosestInSet < closestDistSqr ) {
              closestDistSqr = distSqr2ClosestInSet;
              closest        = closestInSet;
            }
          }
        }
        return closest;
      }
    }
    return null;
  }
  
  

  
  public Intersections collectSetIntersections( LineSeg2 intersectingLine, int resolution ) {
    // Get all the intersection points
    TreeSet<IntersectionPoint> intersectionPoints = new TreeSet<IntersectionPoint>();
    if( sets != null && sets.size() > 0 ) {
      int segmentIndex = 0;
      for( LightSet set : sets ) {
        List<Vector2> setIntersectionPoints = set.collectIntersections( intersectingLine ); 
        for( Vector2 intersectionPoint : setIntersectionPoints ) {
          intersectionPoints.add( new IntersectionPoint( intersectingLine, intersectionPoint, segmentIndex ) );
        }
        ++segmentIndex;
      }
    }

    // Insert them into the array and return it
    Intersections intersections = new Intersections( resolution );
                  intersections.insertAll( intersectionPoints );
    return        intersections;
  }
}

