
import peasy.*;


import processing.opengl.*;

import com.fieldfx.util.*;
import com.fieldfx.geom.mesh.*;
import com.fieldfx.geom.mesh.collada.*;
import com.fieldfx.gfx.*;
import com.fieldfx.math.*;
import com.fieldfx.ui.*;

DrawWriter drawer      = null;
Mesh       example_map = null;
PeasyCam   cam         = null;


// ------------------------------------------------------------------------------- //
void setup() {
  size( 800, 600, OPENGL );
  example_map = loadColladaMesh( "example_map01.dae" );
  drawer      = new DrawWriter( this.g );
  cam         = new PeasyCam( this, 1000 );
}

// ------------------------------------------------------------------------------- //
void draw() {
  background(0);

  fill   ( 100 );
  stroke ( 255 );
  scale  ( 0.1f );
  
  example_map.convert( drawer );
}


// ------------------------------------------------------------------------------- //
Mesh loadColladaMesh( String fileName ) {
  MeshBuilderBase builder = new MeshBuilderBase( this );
  COLLADAReader   collada = new COLLADAReader( this, dataPath( fileName ) );
                  collada.convert( builder );
  return                           builder.getMesh();
}

