image {
	resolution 1280 720
	aa 1 3
	samples 2
	filter triangle
}
trace-depths {
	diff 4 
	refl 4 
	refr 12
}

bucket 16 hilbert

photons {
	caustics 1000000 kd 100 0.5
}

gi {
	type irr-cache
	samples 1024
	tolerance 0.00999999977648
	spacing 0.0500000007451 5.0
}


shader {
	name iplane
	type diffuse
	diff 1.0 1.0 1.0 
}

object {
	shader iplane
	type plane
	p 0 0 0
	n 0 0 1
}


shader {
	name def
	type diffuse
	diff 1 1 1
}

shader {
	name "backwall.shader"
	type diffuse
	diff { "sRGB nonlinear" 1.000 1.000 1.000 }
}

shader {
	name "fieldfx.shader"
	type diffuse
	diff { "sRGB nonlinear" 1.000 1.000 1.000 }
}

shader {
	name "mlmat.shader"
	type diffuse
	diff { "sRGB nonlinear" 1.000 1.000 1.000 }
}

shader {
	name "sfgla_block01.shader"
	type glass
	eta 1.5
	color { "sRGB nonlinear" 0.021 0.782 0.326 }
	absorbtion.distance 3.0
	absorbtion.color { "sRGB nonlinear" 1.000 1.000 1.000 }
}

shader {
	name "sfgla_block02.shader"
	type glass
	eta 1.5
	color { "sRGB nonlinear" 0.560 0.367 0.821 }
	absorbtion.distance 3.0
	absorbtion.color { "sRGB nonlinear" 1.000 1.000 1.000 }
}

shader {
	name "sfgla_block03.shader"
	type glass
	eta 1.5
	color { "sRGB nonlinear" 1.000 0.000 0.000 }
	absorbtion.distance 3.0
	absorbtion.color { "sRGB nonlinear" 1.000 1.000 1.000 }
}
shader {
	name "wall01.shader"
	type diffuse
	diff { "sRGB nonlinear" 1.000 0.309 0.000 }
}

shader {
	name "wall02.shader"
	type diffuse
	diff { "sRGB nonlinear" 0.411 0.531 0.996 }
}

camera {
	type   thinlens
	eye    0.446141 -13.403035 2.328376
	target 0.598687 -12.416791 2.392031
	up     -0.068729 -0.053667 0.996191
	fov    42.4940749657 
	aspect 1.5 
	fdist 13.3200025558 
	lensr 0.5
	sides 12 
	rotation 0.0 
}

light {
	type meshlight
	name "meshlight01"
	emit { "sRGB nonlinear" 1.000 1.000 1.000 }
	radiance 500
	samples 16
	points 4
		4.185250 -0.613906 10.594720
		4.014803 -4.296132 10.429212
		0.329397 -4.123044 10.373792
		0.499847 -0.440818 10.539300
	triangles 2
		0 3 2
		0 2 1
}

include "FieldFX.geo.sc"
