package test;

import static org.junit.Assert.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import com.fieldfx.math.Poly2;
import com.fieldfx.math.Space2;
import com.fieldfx.math.Vector2;

public class Space2Test {
  private static final float   eps = 0.0001f;
  
  private Vector2 v = new Vector2( 1, 0 ); 
  private Space2  s = null;
  
  @Before
  public void runBeforeEveryTest() { 
    s = new Space2();
    s.setAng( 3.14159f * 0.5f );
    s.set(1.f, 1.f);
  }
  @After 
  public void runAfterEveryTest()  { s = null; }
  @Test
  public void testSetAng() {
                        s.setAng( 3.14159f );
    Vector2       vIn = s.transformIn(v);
    assertEquals( vIn.sub( new Vector2(0.f, -1.f) ).lenlen(), 0, eps );
  }

  @Test
  public void testRot() {
                        s.rot( 3.14159f * 0.5f );
    Vector2       vIn = s.transformIn(v);
    assertEquals( vIn.sub( new Vector2(0.f, -1.f) ).lenlen(), 0, eps );
  }

  @Test
  public void testTransformInPoint() {
    Vector2       vIn = s.transformIn(v);
    assertEquals( vIn.sub( new Vector2(-1.f, 0.0f) ).lenlen(), 0, eps );
  }

  @Test
  public void testTransformInVector() {
    Vector2       vIn = s.transformIn(v,true);
    assertEquals( vIn.sub( new Vector2(0.f, 1.0f) ).lenlen(), 0, eps );
  }

  @Test
  public void testTransformOutPoint() {
    Vector2       vOut = s.transformOut(v);
    assertEquals( vOut.sub( new Vector2(1.f, 2.0f) ).lenlen(), 0, eps );
  }

  @Test
  public void testTransformOutVector() {
    Vector2       vOut = s.transformOut(v,true);
    assertEquals( vOut.sub( new Vector2(0.f, 1.0f) ).lenlen(), 0, eps );
  }

}
