package com.fieldfx.geom.mesh;

import java.util.ArrayList;

import com.fieldfx.math.LineSeg3;
import com.fieldfx.math.Vector3;

import com.fieldfx.util.SelectableBase;
import com.fieldfx.util.serialize.Serializable;
import com.fieldfx.util.serialize.Serializer;


public class Edge extends SelectableBase implements Serializable {

  public    Vertex  first    = null;
  public    Vertex  second   = null;
  public    Edge    previous = null;
  public    Edge    next     = null;
  public    Face    inside   = null;
  public    Face    outside  = null;
  public    float   bulge    = 0;
  protected int     index    = 0;
  
  
  
  // ---------------------------------------------------------------- //
  public String getType()  { return "edge"; }
  public int    getIndex() { return index; }
  // ---------------------------------------------------------------- //
  public ArrayList<Vertex> getVerts() {
    ArrayList<Vertex> verts = new ArrayList<Vertex>();
    verts.add(first);
    verts.add(second);
    return verts;
  }
  // ---------------------------------------------------------------- //
  public LineSeg3 getAsLineSeg3() {
    return new LineSeg3( first, second );
  }
  
  // ---------------------------------------------------------------- //
  public Vector3 getMin( Vector3 min ) {
    return null;
  }
  // ---------------------------------------------------------------- //
  public Vector3 getMax( Vector3 max ) {
    return null;
  }
  // ---------------------------------------------------------------- //  
  @Override
  public void serialize( Serializer s ) {
            s.serialize( "first",    first    );
            s.serialize( "second",   second   );
            s.serialize( "previous", previous );
            s.serialize( "next",     next     );
            s.serialize( "inside",   inside   );
            s.serialize( "outside",  outside  );
    
    bulge = s.serialize( "bulge",    bulge    );
    index = s.serialize( "index",    index    );
  }
  // ---------------------------------------------------------------- //
  @Override
  public Serializable clone() {
    return new Edge();
  }
}
