package com.fieldfx.net;

// -------------------------------------------------------------------------------- //
  // Unique ID generation
  class NetObjectIDBank {
    private int nextID = NetObject.invalid_id;
    private int lastID = NetObject.invalid_id;

    public void init(int firstID, int lastID) { 
      this.nextID = firstID;
      this.lastID = lastID;
    }

    // Reserves a single ID, if available
    public int reserveID() {
      if(nextID < lastID) {
        return nextID++;
      } else {
        return NetObject.invalid_id;
      }
    }
    
    // Reserves a range of IDs, if available
    public int reserveIDRange( int numIDs ) {
      int ret = NetObject.invalid_id;
      
      if(nextID + numIDs < lastID) {
        ret     = nextID;
        nextID += numIDs;
      }
      
      return ret;
    }

  }