package com.fieldfx.net;

import java.util.List;

public abstract class NetRule {
  protected float radrad = 10.0f;
  protected float factor = 1.0f;
  
  public void updateRelation( NetObject a, NetObject b, NetMesh parent ) {
    // If the squared length between the two objects is less than the squared radius of this relation
    //  then we want to update the relation so it continues to exist.
    if( a.pos.sub( b.pos ).lenlen() < radrad ) {
      parent.updateRelation(a,b);
    }
  }
  
  public abstract void apply( NetObject a, List<NetObject> relations );
}
