/*
  Caffeine Processing Libraries
  
  (c) copyright
  
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
 */

package com.fieldfx.ui;

public class UIFactory {
  
  //private static int   uniqueIndex    = 0;
  
  private UIManager    parent;
  private UIContainer  container;

  public UIFactory( UIManager parent, UIContainer container ) {
    this.parent    = parent;
    this.container = container;
  }

  /// Creates a new UIBox in the main view 
  public UIBox            newBox               ()  { return (UIBox)container.bringToFront( container.addChild( new UIBox( parent, container ) ) ); }
  /// Creates a new UIFrame in the main view    
  public UIFrame          newFrame             ()  { return (UIFrame)container.bringToFront( container.addChild( new UIFrame( parent, container ) ) ); }
  /// Creates a new UIWindow in the main view
  public UIWindow         newWindow            ()  { return (UIWindow)container.bringToFront( container.addChild( new UIWindow( parent, container) ) ); }
  /// Creates a new UIButton in the main view
  public UIButton         newButton            ()  { return (UIButton)container.bringToFront( container.addChild( new UIButton( parent, container ) ) ); }
  /// Creates a new UISlider in the main view
  public UISlider         newSlider            ()  { return (UISlider)container.bringToFront( container.addChild( new UISlider( parent, container ) ) ); }
  /// Creates a new UIKnob in the main view
  public UIKnob           newKnob              ()  { return (UIKnob)container.bringToFront( container.addChild( new UIKnob( parent, container ) ) ); }
  /// Creates a new UIInfinitePlane in the main view
  public UIInfinitePlane  newInfinitePlane     ()  { return (UIInfinitePlane)container.sendToBack( container.addChild( new UIInfinitePlane( parent, container ) ) ); }
}