/*
  ScriptableMill
  copyright (c) 2011, Jack W. Kern
 */
package com.fieldfx.util;

import java.util.List;

import com.fieldfx.util.NamedMultiMap;
import com.fieldfx.geom.mesh.Edge;
import com.fieldfx.geom.mesh.Face;
import com.fieldfx.geom.mesh.PolyLine;
import com.fieldfx.geom.mesh.Vertex;
import com.fieldfx.math.Vector3;


public interface Selectable {
  public  List<Vertex>            getVerts  ( );
  public  List<Edge>              getEdges  ( );
  public  NamedMultiMap<PolyLine> getPolys  ( );
  public  NamedMultiMap<Face>     getFaces  ( );

  public  String                  getType   ( );
  public  int                     getIndex  ( );
  public  Vector3                 getMin    ( Vector3 min );
  public  Vector3                 getMax    ( Vector3 max );
}
