/*
  Caffeine Processing Libraries
  
  (c) copyright
  
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
 */
 
package com.fieldfx.ui;

import processing.core.PGraphics;
import processing.core.PImage;

public interface UIDrawer
{
  // Box types
  final static int BOX        = 0;
  final static int HIGHLIGHT  = 1;
  final static int EDITBOX    = 2;
  final static int TITLEBAR   = 3;
  final static int SHADOW     = 4;
  final static int BUTTON     = 5;
  final static int SLIDEAREA  = 6;
  
  // Text types
  final static int LABEL    = 7;
  final static int TITLE    = 8;
  final static int CODE     = 9;
  //final static int EDITBOX
  

  public PGraphics  graphics();
  
  public PImage     getCloseButton();
  public PImage[]   getMinButton();
  public PImage[]   getPinnedButton();

  public void       translate   ( float x, float y );
  public void       rotate      ( float angle );
  public void       scale       ( float scale );
  public void       pushMatrix  ();
  public void       popMatrix   ();
  
  public float      textWidth   ( String text );
  //public void       shade       ( float  shade );
  public void       boxType     ( int    type );
  public void       box         ( float x, float y, float width, float height );
  public void       image       ( PImage img, float x, float y, float width, float height );
  public void       image       ( PImage img );
    
  public void       knob        ( float x, float y, float diameter  );
  public void       notch       ( float x, float y, float width     );
  public void       arrow       ( float x, float y, int   direction );

  public void       beginBorder ( float borderWidth, float depth, int nesting );
  public void       corner      ( float x, float y, float radius );
  public void       endBorder   ( boolean close );

  public void       textType    ( int type );
  public void       text        ( String text, float x, float y );
}




