/*
  Caffeine Processing Libraries
  
  (c) copyright
  
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General
  Public License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
  Boston, MA  02111-1307  USA
 */
 
package com.fieldfx.ui;

import com.fieldfx.math.Vector2;

import processing.core.PImage;
import processing.core.PGraphics;
//import processing.opengl.*;
//import javax.media.opengl.*;
//import com.sun.opengl.util.texture.*; 
//import java.io.File;


public class UIInfinitePlane extends UIElement
{
  //protected Texture  PlaneTex = null;
  protected PImage   planeTex = null;
  protected Vector2  vTexSize = null;
  
  // -------------------------------------------------------------------------------------------------------------- //
  public UIInfinitePlane( UIManager parent, UIContainer container ) {
    super( parent, container );
  }
  
  // -------------------------------------------------------------------------------------------------------------- //
  public UIInfinitePlane  setPos         ( float x, float y )   { return (UIInfinitePlane)super.setPos(x,y); }
  public UIInfinitePlane  setPos         ( Vector2 pos )        { return (UIInfinitePlane)super.setPos(pos); }
  public UIInfinitePlane  show           ( )                    { return (UIInfinitePlane)super.show(); }
  public UIInfinitePlane  hide           ( )                    { return (UIInfinitePlane)super.hide(); }  
  public UIInfinitePlane  setFocus       ( )                    { return (UIInfinitePlane)super.setFocus(); }   
  public UIInfinitePlane  setFocus       ( boolean bSet )       { return (UIInfinitePlane)super.setFocus( bSet ); }     
  public UIInfinitePlane  bringToFront   ( )                    { return (UIInfinitePlane)super.bringToFront(); }
  public UIInfinitePlane  sendToBack     ( )                    { return (UIInfinitePlane)super.sendToBack(); }
  
  // -------------------------------------------------------------------------------------------------------------- //
  public UIInfinitePlane  Load( String strTextureFile ) {
    //try { PlaneTex = TextureIO.newTexture( new File( getApp().dataPath( strTextureFile ) ), true ); }
    //catch( Exception e ) { getApp().println(e); }
    planeTex = getApp().loadImage( strTextureFile );
    //vTexSize = new Vector2( PlaneTex.getWidth(), PlaneTex.getHeight() );
    vTexSize = new Vector2( planeTex.width, planeTex.height );
    return this;    
  }

  // -------------------------------------------------------------------------------------------------------------- //
  @SuppressWarnings("deprecation")
  public void draw( UIDrawer d )
  {
    if( planeTex == null )
      return;

    Vector2 vMin        = parent.getView().clientToWorld( new Vector2(), new Vector2() );
    Vector2 vMax        = parent.getView().clientToWorld( new Vector2(), new Vector2( getApp().width, getApp().height ) );
    //Vector2 vTex        = parent.getView().clientToWorld( new Vector2(), new Vector2( vTexSize.x,     vTexSize.y ) );
    
    Vector2 vDeskSize   = vMax.sub( vMin );
    Vector2 vTileOffset = vMin.mod( vTexSize ).diveq(vTexSize);
    Vector2 vTileCount  = vDeskSize.div(vTexSize);
    
    PGraphics g = d.graphics();
    
    //PGraphicsOpenGL pgl = (PGraphicsOpenGL)d.graphics(); 
    //GL               gl = pgl.beginGL(); 
  
    //gl.glClear( GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT );
    //gl.glDisable( GL.GL_DEPTH_TEST );
  
    
    //PlaneTex.bind();
    //PlaneTex.enable();
      //gl.glTexParameteri  ( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_S, GL.GL_REPEAT );
      //gl.glTexParameteri  ( GL.GL_TEXTURE_2D, GL.GL_TEXTURE_WRAP_T, GL.GL_REPEAT );
    
      g.textureMode( NORMALIZED );
      g.beginShape();
      g.texture(planeTex);
      //gl.glBegin          ( GL.GL_QUADS   );
       //gl.glColor3f        ( 1.0f, 1.0f, 1.0f );
       //gl.glTexCoord2f     ( vTileOffset.x,              vTileOffset.y              ); gl.glVertex2f( vMin.x, vMin.y );
       g.vertex( vMin.x, vMin.y, vTileOffset.x,              vTileOffset.y              );
       //gl.glColor3f        ( 1.0f, 1.0f, 1.0f );
       //gl.glTexCoord2f     ( vTileOffset.x,              vTileOffset.y+vTileCount.y ); gl.glVertex2f( vMin.x, vMax.y );
       g.vertex( vMin.x, vMax.y, vTileOffset.x,              vTileOffset.y+vTileCount.y );
       //gl.glColor3f        ( 1.0f, 1.0f, 1.0f );
       //gl.glTexCoord2f     ( vTileOffset.x+vTileCount.x, vTileOffset.y+vTileCount.y ); gl.glVertex2f( vMax.x, vMax.y );
       g.vertex( vMax.x, vMax.y, vTileOffset.x+vTileCount.x, vTileOffset.y+vTileCount.y );
       //gl.glColor3f        ( 1.0f, 1.0f, 1.0f );
       //gl.glTexCoord2f     ( vTileOffset.x+vTileCount.x, vTileOffset.y              ); gl.glVertex2f( vMax.x, vMin.y );
       g.vertex( vMax.x, vMin.y, vTileOffset.x+vTileCount.x, vTileOffset.y );
      //gl.glEnd(); 
      g.endShape();
    //PlaneTex.disable();      
    
    //pgl.endGL();
  }
}